#include "GameObject.h"
#include "TextureManager.h"
#include "Game.h"


void GameObject::load(int x, int y, int width, int height, std::string textureID)
{
  m_x = x;
  m_y = y;
  m_width = width;
  m_height = height;

  m_destHeight = Game::Instance()->getScaleHeight() * height / Game::Instance()->getGameHeight();
  m_destWidth = Game::Instance()->getScaleWidth() * width / Game::Instance()->getGameWidth();

  m_textureID = textureID;

  m_currentRow = 1;
  m_currentFrame = 1;
  m_active = true;
}

void GameObject::load(int x, int y, int width, int height)
{
  m_x = x;
  m_y = y;
  m_width = width;
  m_height = height;

  m_destHeight = Game::Instance()->getScaleHeight() * height / Game::Instance()->getGameHeight();
  m_destWidth = Game::Instance()->getScaleWidth() * width / Game::Instance()->getGameWidth();


  m_textureID = "none";

  m_currentRow = 1;
  m_currentFrame = 1;
  m_active = true;
}

void GameObject::draw(SDL_Renderer* pRenderer)
{
	if (isActive()) {
		int scaleXpos = Game::Instance()->getScaleWidth() * m_x
				/ Game::Instance()->getGameWidth();
		int scaleYpos = Game::Instance()->getScaleHeight() * m_y
				/ Game::Instance()->getGameHeight();
		int scaleWidth = Game::Instance()->getScaleWidth() * m_width
				/ Game::Instance()->getGameWidth();
		int scaleHeight = Game::Instance()->getScaleHeight() * m_height
				/ Game::Instance()->getGameHeight();

		//TextureManager::Instance()->drawFrame(m_textureID, scaleXpos, scaleYpos, m_width, m_height, m_currentRow, m_currentFrame, pRenderer);
		//TextureManager::Instance()->scaleFrame(m_textureID, m_x)
		TextureManager::Instance()->scaleFrame(m_textureID, m_x, m_y, m_width,
				m_height, m_destWidth, m_destHeight, scaleXpos, scaleYpos,
				m_currentRow, m_currentFrame, pRenderer, SDL_FLIP_NONE);
	}
}

void GameObject::update()
{
  //m_currentFrame = int(((SDL_GetTicks() / 100) % 6));
	m_currentFrame = 0;
  //m_x += 1;
  //m_currentFrame = ( m_currentFrame + 1) % 6;
  
}

void GameObject::clean()
{

  
}

